"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMainnetTokens = void 0;
const spl_token_registry_1 = require("@solana/spl-token-registry");
function getMainnetTokens() {
    return __awaiter(this, void 0, void 0, function* () {
        // initialize token list provider
        const tokens = yield (new spl_token_registry_1.TokenListProvider()).resolve();
        // filter out tokens that are not on mainnet
        const tokenList = tokens.filterByChainId(101).getList();
        // convert tokenInfos to tokens type
        var tokenInfos = [];
        for (const token of tokenList) {
            const tokenInfo = {
                value: token.name,
                label: token.symbol,
                logo: token.logoURI,
                mint: token.address,
                decimals: token.decimals
            };
            tokenInfos.push(tokenInfo);
        }
        // sort tokens by name
        tokenInfos = tokenInfos.sort((a, b) => a.label.toLowerCase().localeCompare(b.label.toLowerCase()));
        return tokenInfos;
    });
}
exports.getMainnetTokens = getMainnetTokens;
